Index: qtbase-everywhere-src-5.13.1/src/gui/text/qstatictext.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qstatictext.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qstatictext.cpp
@@ -465,7 +465,7 @@ namespace {
             QTransform matrix = m_untransformedCoordinates ? QTransform() : state->transform();
             matrix.translate(position.x(), position.y());
 
-            QVarLengthArray<glyph_t> glyphs;
+            QVarLengthArray<QGlyph> glyphs;
             QVarLengthArray<QFixedPoint> positions;
             ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
 
@@ -476,8 +476,8 @@ namespace {
             m_glyphs.resize(m_glyphs.size() + size);
             m_positions.resize(m_glyphs.size());
 
-            glyph_t *glyphsDestination = m_glyphs.data() + currentItem.glyphOffset;
-            memcpy(glyphsDestination, glyphs.constData(), sizeof(glyph_t) * currentItem.numGlyphs);
+            QGlyph *glyphsDestination = m_glyphs.data() + currentItem.glyphOffset;
+            memcpy(glyphsDestination, glyphs.constData(), sizeof(QGlyph) * currentItem.numGlyphs);
 
             QFixedPoint *positionsDestination = m_positions.data() + currentItem.positionOffset;
             memcpy(positionsDestination, positions.constData(), sizeof(QFixedPoint) * currentItem.numGlyphs);
@@ -508,7 +508,7 @@ namespace {
             return m_positions;
         }
 
-        QVector<glyph_t> glyphs() const
+        QVector<QGlyph> glyphs() const
         {
             return m_glyphs;
         }
@@ -516,7 +516,7 @@ namespace {
     private:
         QVector<QStaticTextItem> m_items;
         QVector<QFixedPoint> m_positions;
-        QVector<glyph_t> m_glyphs;
+        QVector<QGlyph> m_glyphs;
 
         bool m_dirtyPen;
         bool m_useBackendOptimizations;
@@ -580,7 +580,7 @@ namespace {
             return m_paintEngine;
         }
 
-        QVector<glyph_t> glyphs() const
+        QVector<QGlyph> glyphs() const
         {
             return m_paintEngine->glyphs();
         }
@@ -686,13 +686,13 @@ void QStaticTextPrivate::init()
 
     QVector<QStaticTextItem> deviceItems = device.items();
     QVector<QFixedPoint> positions = device.positions();
-    QVector<glyph_t> glyphs = device.glyphs();
+    QVector<QGlyph> glyphs = device.glyphs();
 
     itemCount = deviceItems.size();
     items = new QStaticTextItem[itemCount];
 
-    glyphPool = new glyph_t[glyphs.size()];
-    memcpy(glyphPool, glyphs.constData(), glyphs.size() * sizeof(glyph_t));
+    glyphPool = new QGlyph[glyphs.size()];
+    memcpy(glyphPool, glyphs.constData(), glyphs.size() * sizeof(QGlyph));
 
     positionPool = new QFixedPoint[positions.size()];
     memcpy(positionPool, positions.constData(), positions.size() * sizeof(QFixedPoint));
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qstatictext_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qstatictext_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qstatictext_p.h
@@ -100,11 +100,11 @@ public:
         int positionOffset;
     };
     union {
-        glyph_t *glyphs;                         // 4 bytes per glyph
+        QGlyph *glyphs;                          // 8 bytes per glyph
         int glyphOffset;
     };
                                                  // =================
-                                                 // 12 bytes per glyph
+                                                 // 16 bytes per glyph
 
                                                  // 8 bytes for pointers
     int numGlyphs;                               // 4 bytes per item
@@ -150,7 +150,7 @@ public:
     QStaticTextItem *items;              // 4 bytes per text
     int itemCount;                       // 4 bytes per text
 
-    glyph_t *glyphPool;                  // 4 bytes per text
+    QGlyph *glyphPool;                   // 8 bytes per text
     QFixedPoint *positionPool;           // 4 bytes per text
 
     QTextOption textOption;              // 28 bytes per text
@@ -160,7 +160,7 @@ public:
     unsigned char textFormat               : 2;
     unsigned char untransformedCoordinates : 1;
                                          // ================
-                                         // 191 bytes per text
+                                         // 195 bytes per text
 
     static QStaticTextPrivate *get(const QStaticText *q);
 };
Index: qtbase-everywhere-src-5.13.1/src/gui/text/qtextlayout.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/text/qtextlayout.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/text/qtextlayout.cpp
@@ -1663,7 +1663,7 @@ namespace {
         int glyphCount;
         int maxGlyphs;
         int currentPosition;
-        glyph_t previousGlyph;
+        QGlyph previousGlyph;
         QFontEngine *previousGlyphFontEngine;
 
         QFixed minw;
@@ -1684,17 +1684,17 @@ namespace {
                     + softHyphenWidth + negativeRightBearing();
         }
 
-        inline glyph_t currentGlyph() const
+        inline QGlyph currentGlyph() const
         {
             Q_ASSERT(currentPosition > 0);
             Q_ASSERT(logClusters[currentPosition - 1] < glyphs.numGlyphs);
 
-            return glyphs.glyphs[logClusters[currentPosition - 1]];
+            return glyphs.at(logClusters[currentPosition - 1]);
         }
 
         inline void saveCurrentGlyph()
         {
-            previousGlyph = 0;
+            previousGlyph = {0, 0};
             if (currentPosition > 0 &&
                 logClusters[currentPosition - 1] < glyphs.numGlyphs) {
                 previousGlyph = currentGlyph(); // needed to calculate right bearing later
@@ -1702,7 +1702,7 @@ namespace {
             }
         }
 
-        inline void calculateRightBearing(QFontEngine *engine, glyph_t glyph)
+        inline void calculateRightBearing(QFontEngine *engine, const QGlyph &glyph)
         {
             qreal rb;
             engine->getGlyphBearings(glyph, 0, &rb);
@@ -1723,7 +1723,7 @@ namespace {
 
         inline void calculateRightBearingForPreviousGlyph()
         {
-            if (previousGlyph > 0)
+            if (previousGlyph.glyph > 0)
                 calculateRightBearing(previousGlyphFontEngine, previousGlyph);
         }
 
@@ -1830,7 +1830,7 @@ void QTextLine::layout_helper(int maxGly
     lbh.currentPosition = line.from;
     int end = 0;
     lbh.logClusters = eng->layoutData->logClustersPtr;
-    lbh.previousGlyph = 0;
+    lbh.previousGlyph = {};
 
     bool hasInlineObject = false;
     QFixed maxInlineObjectHeight = 0;
@@ -2238,7 +2238,7 @@ static QGlyphRun glyphRunWithInfo(QFontE
     QRawFontPrivate *fontD = QRawFontPrivate::get(font);
     fontD->setFontEngine(fontEngine);
 
-    QVarLengthArray<glyph_t> glyphsArray;
+    QVarLengthArray<QGlyph> glyphsArray;
     QVarLengthArray<QFixedPoint> positionsArray;
 
     QTextItem::RenderFlags renderFlags;
@@ -2263,7 +2263,7 @@ static QGlyphRun glyphRunWithInfo(QFontE
     QVector<QPointF> positions;
     positions.reserve(glyphsArray.size());
     for (int i=0; i<glyphsArray.size(); ++i) {
-        glyphs.append(glyphsArray.at(i) & 0xffffff);
+        glyphs.append(glyphsArray.at(i).glyph);
 
         QPointF position = positionsArray.at(i).toPointF() + pos;
         positions.append(position);
@@ -2405,10 +2405,10 @@ QList<QGlyphRun> QTextLine::glyphRuns(in
                 QFontEngineMulti *multiFontEngine = static_cast<QFontEngineMulti *>(mainFontEngine);
                 int start = rtl ? glyphLayout.numGlyphs : 0;
                 int end = start - 1;
-                int which = glyphLayout.glyphs[rtl ? start - 1 : end + 1] >> 22;
+                int which = glyphLayout.glyphs[rtl ? start - 1 : end + 1].engine;
                 for (; (rtl && start > 0) || (!rtl && end < glyphLayout.numGlyphs - 1);
                      rtl ? --start : ++end) {
-                    const int e = glyphLayout.glyphs[rtl ? start - 1 : end + 1] >> 22;
+                    const int e = glyphLayout.glyphs[rtl ? start - 1 : end + 1].engine;
                     if (e == which)
                         continue;
 
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpainter_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpainter_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpainter_p.h
@@ -63,6 +63,7 @@
 #include "QtGui/qpaintengine.h"
 
 #include <private/qpen_p.h>
+#include <private/qtextengine_p.h>
 
 QT_BEGIN_NAMESPACE
 
@@ -234,7 +235,7 @@ public:
     void drawTextItem(const QPointF &p, const QTextItem &_ti, QTextEngine *textEngine);
 
 #if !defined(QT_NO_RAWFONT)
-    void drawGlyphs(const quint32 *glyphArray, QFixedPoint *positionArray, int glyphCount,
+    void drawGlyphs(const QGlyph *glyphArray, QFixedPoint *positionArray, int glyphCount,
                     QFontEngine *fontEngine, bool overline = false, bool underline = false,
                     bool strikeOut = false);
 #endif
Index: qtbase-everywhere-src-5.13.1/src/gui/opengl/qopenglpaintengine.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/opengl/qopenglpaintengine.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/opengl/qopenglpaintengine.cpp
@@ -1670,7 +1670,7 @@ void QOpenGL2PaintEngineEx::drawTextItem
 
     if (shouldDrawCachedGlyphs(ti.fontEngine, s->matrix)) {
         QVarLengthArray<QFixedPoint> positions;
-        QVarLengthArray<glyph_t> glyphs;
+        QVarLengthArray<QGlyph> glyphs;
         QTransform matrix = QTransform::fromTranslate(p.x(), p.y());
         ti.fontEngine->getGlyphPositions(ti.glyphs, matrix, ti.flags, glyphs, positions);
 
Index: qtbase-everywhere-src-5.13.1/src/gui/opengl/qopengltextureglyphcache.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/opengl/qopengltextureglyphcache.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/opengl/qopengltextureglyphcache.cpp
@@ -421,7 +421,7 @@ void QOpenGLTextureGlyphCache::resizeTex
     }
 }
 
-void QOpenGLTextureGlyphCache::fillTexture(const Coord &c, glyph_t glyph, QFixed subPixelPosition)
+void QOpenGLTextureGlyphCache::fillTexture(const Coord &c, const QGlyph &glyph, QFixed subPixelPosition)
 {
     QOpenGLContext *ctx = QOpenGLContext::currentContext();
     if (ctx == 0) {
Index: qtbase-everywhere-src-5.13.1/src/gui/opengl/qopengltextureglyphcache_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/opengl/qopengltextureglyphcache_p.h
+++ qtbase-everywhere-src-5.13.1/src/gui/opengl/qopengltextureglyphcache_p.h
@@ -115,7 +115,7 @@ public:
 
     virtual void createTextureData(int width, int height) override;
     virtual void resizeTextureData(int width, int height) override;
-    virtual void fillTexture(const Coord &c, glyph_t glyph, QFixed subPixelPosition) override;
+    virtual void fillTexture(const Coord &c, const QGlyph &glyph, QFixed subPixelPosition) override;
     virtual int glyphPadding() const override;
     virtual int maxTextureWidth() const override;
     virtual int maxTextureHeight() const override;
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qpdf.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qpdf.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qpdf.cpp
@@ -2951,7 +2951,7 @@ void QPdfEnginePrivate::drawTextItem(con
 
     qreal size = ti.fontEngine->fontDef.pixelSize;
 
-    QVarLengthArray<glyph_t> glyphs;
+    QVarLengthArray<QGlyph> glyphs;
     QVarLengthArray<QFixedPoint> positions;
     QTransform m = QTransform::fromTranslate(p.x(), p.y());
     ti.fontEngine->getGlyphPositions(ti.glyphs, m, ti.flags,
@@ -3001,7 +3001,7 @@ void QPdfEnginePrivate::drawTextItem(con
             x += .3*y;
         x /= stretch;
         char buf[5];
-        int g = font->addGlyph(glyphs[i]);
+        int g = font->addGlyph(glyphs[i].glyph);
         *currentPage << x - last_x << last_y - y << "Td <"
                      << QPdf::toHex((ushort)g, buf) << "> Tj\n";
         last_x = x;
@@ -3021,7 +3021,7 @@ void QPdfEnginePrivate::drawTextItem(con
                 x += .3*y;
             x /= stretch;
             char buf[5];
-            int g = font->addGlyph(glyphs[i]);
+            int g = font->addGlyph(glyphs[i].glyph);
             *currentPage << x - last_x << last_y - y << "Td <"
                         << QPdf::toHex((ushort)g, buf) << "> Tj\n";
             last_x = x;
Index: qtbase-everywhere-src-5.13.1/src/gui/painting/qtextureglyphcache.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/gui/painting/qtextureglyphcache.cpp
+++ qtbase-everywhere-src-5.13.1/src/gui/painting/qtextureglyphcache.cpp
@@ -52,7 +52,7 @@ QTextureGlyphCache::~QTextureGlyphCache(
 {
 }
 
-int QTextureGlyphCache::calculateSubPixelPositionCount(glyph_t glyph) const
+int QTextureGlyphCache::calculateSubPixelPositionCount(const QGlyph &glyph) const
 {
     // Test 12 different subpixel positions since it factors into 3*4 so it gives
     // the coverage we need.
@@ -90,7 +90,7 @@ int QTextureGlyphCache::calculateSubPixe
     return numImages;
 }
 
-bool QTextureGlyphCache::populate(QFontEngine *fontEngine, int numGlyphs, const glyph_t *glyphs,
+bool QTextureGlyphCache::populate(QFontEngine *fontEngine, int numGlyphs, const QGlyph *glyphs,
                                                 const QFixedPoint *positions)
 {
 #ifdef CACHE_DEBUG
@@ -123,7 +123,7 @@ bool QTextureGlyphCache::populate(QFontE
 
     // check each glyph for its metrics and get the required rowHeight.
     for (int i=0; i < numGlyphs; ++i) {
-        const glyph_t glyph = glyphs[i];
+        const QGlyph glyph = glyphs[i];
 
         QFixed subPixelPosition;
         if (supportsSubPixelPositions) {
@@ -261,7 +261,7 @@ void QTextureGlyphCache::fillInPendingGl
     m_pendingGlyphs.clear();
 }
 
-QImage QTextureGlyphCache::textureMapForGlyph(glyph_t g, QFixed subPixelPosition) const
+QImage QTextureGlyphCache::textureMapForGlyph(const QGlyph &g, QFixed subPixelPosition) const
 {
     switch (m_format) {
     case QFontEngine::Format_A32:
@@ -307,7 +307,7 @@ void QImageTextureGlyphCache::createText
     }
 }
 
-void QImageTextureGlyphCache::fillTexture(const Coord &c, glyph_t g, QFixed subPixelPosition)
+void QImageTextureGlyphCache::fillTexture(const Coord &c, const QGlyph &g, QFixed subPixelPosition)
 {
     QImage mask = textureMapForGlyph(g, subPixelPosition);
 
Index: qtbase-everywhere-src-5.13.1/src/opengl/gl2paintengineex/qtextureglyphcache_gl_p.h
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/opengl/gl2paintengineex/qtextureglyphcache_gl_p.h
+++ qtbase-everywhere-src-5.13.1/src/opengl/gl2paintengineex/qtextureglyphcache_gl_p.h
@@ -115,7 +115,7 @@ public:
 
     virtual void createTextureData(int width, int height) override;
     virtual void resizeTextureData(int width, int height) override;
-    virtual void fillTexture(const Coord &c, glyph_t glyph, QFixed subPixelPosition) override;
+    virtual void fillTexture(const Coord &c, const QGlyph &glyph, QFixed subPixelPosition) override;
     virtual int glyphPadding() const override;
     virtual int maxTextureWidth() const override;
     virtual int maxTextureHeight() const override;
Index: qtbase-everywhere-src-5.13.1/src/platformsupport/fontdatabases/freetype/qfontengine_ft.cpp
===================================================================
--- qtbase-everywhere-src-5.13.1.orig/src/platformsupport/fontdatabases/freetype/qfontengine_ft.cpp
+++ qtbase-everywhere-src-5.13.1/src/platformsupport/fontdatabases/freetype/qfontengine_ft.cpp
@@ -178,7 +178,7 @@ int QFreetypeFace::fsType() const
     return fsType;
 }
 
-int QFreetypeFace::getPointInOutline(glyph_t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints)
+int QFreetypeFace::getPointInOutline(glyph__t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints)
 {
     if (int error = FT_Load_Glyph(face, glyph, flags))
         return error;
@@ -1563,11 +1563,11 @@ QFontEngineFT::QGlyphSet *QFontEngineFT:
     return gs;
 }
 
-void QFontEngineFT::getUnscaledGlyph(glyph_t glyph, QPainterPath *path, glyph_metrics_t *metrics)
+void QFontEngineFT::getUnscaledGlyph(const QGlyph &glyph, QPainterPath *path, glyph_metrics_t *metrics)
 {
     FT_Face face = lockFace(Unscaled);
     FT_Set_Transform(face, 0, 0);
-    FT_Load_Glyph(face, glyph, FT_LOAD_NO_BITMAP);
+    FT_Load_Glyph(face, glyph.glyph, FT_LOAD_NO_BITMAP);
 
     int left  = face->glyph->metrics.horiBearingX;
     int right = face->glyph->metrics.horiBearingX + face->glyph->metrics.width;
@@ -1607,14 +1607,14 @@ void QFontEngineFT::addOutlineToPath(qre
         QFontEngine::addOutlineToPath(x, y, glyphs, path, flags);
     } else {
         QVarLengthArray<QFixedPoint> positions;
-        QVarLengthArray<glyph_t> positioned_glyphs;
+        QVarLengthArray<QGlyph> positioned_glyphs;
         QTransform matrix;
         matrix.translate(x, y);
         getGlyphPositions(glyphs, matrix, flags, positioned_glyphs, positions);
 
         FT_Face face = lockFace(Unscaled);
         for (int gl = 0; gl < glyphs.numGlyphs; gl++) {
-            FT_UInt glyph = positioned_glyphs[gl];
+            FT_UInt glyph = positioned_glyphs[gl].glyph;
             FT_Load_Glyph(face, glyph, FT_LOAD_TARGET_MONO);
             QFreetypeFace::addBitmapToPath(face->glyph, positions[gl], path);
         }
@@ -1622,13 +1622,13 @@ void QFontEngineFT::addOutlineToPath(qre
     }
 }
 
-void QFontEngineFT::addGlyphsToPath(glyph_t *glyphs, QFixedPoint *positions, int numGlyphs,
+void QFontEngineFT::addGlyphsToPath(const QGlyph *glyphs, QFixedPoint *positions, int numGlyphs,
                                     QPainterPath *path, QTextItem::RenderFlags)
 {
     FT_Face face = lockFace(Unscaled);
 
     for (int gl = 0; gl < numGlyphs; gl++) {
-        FT_UInt glyph = glyphs[gl];
+        FT_UInt glyph = glyphs[gl].glyph;
 
         FT_Load_Glyph(face, glyph, FT_LOAD_NO_BITMAP);
 
@@ -1644,9 +1644,9 @@ void QFontEngineFT::addGlyphsToPath(glyp
     unlockFace();
 }
 
-glyph_t QFontEngineFT::glyphIndex(uint ucs4) const
+QGlyph QFontEngineFT::glyphIndex(uint ucs4) const
 {
-    glyph_t glyph = ucs4 < QFreetypeFace::cmapCacheSize ? freetype->cmapCache[ucs4] : 0;
+    glyph__t glyph = ucs4 < QFreetypeFace::cmapCacheSize ? freetype->cmapCache[ucs4] : 0;
     if (glyph == 0) {
         FT_Face face = freetype->face;
         glyph = FT_Get_Char_Index(face, ucs4);
@@ -1671,7 +1671,7 @@ glyph_t QFontEngineFT::glyphIndex(uint u
             freetype->cmapCache[ucs4] = glyph;
     }
 
-    return glyph;
+    return {0, glyph};
 }
 
 bool QFontEngineFT::stringToCMap(const QChar *str, int len, QGlyphLayout *glyphs, int *nglyphs,
@@ -1689,15 +1689,15 @@ bool QFontEngineFT::stringToCMap(const Q
         QStringIterator it(str, str + len);
         while (it.hasNext()) {
             uint uc = it.next();
-            glyphs->glyphs[glyph_pos] = uc < QFreetypeFace::cmapCacheSize ? freetype->cmapCache[uc] : 0;
-            if ( !glyphs->glyphs[glyph_pos] ) {
+            glyphs->glyphs[glyph_pos] = { 0, uc < QFreetypeFace::cmapCacheSize ? freetype->cmapCache[uc] : 0};
+            if ( !glyphs->glyphs[glyph_pos].glyph ) {
                 // Symbol fonts can have more than one CMAPs, FreeType should take the
                 // correct one for us by default, so we always try FT_Get_Char_Index
                 // first. If it didn't work (returns 0), we will explicitly set the
                 // CMAP to symbol font one and try again. symbol_map is not always the
                 // correct one because in certain fonts like Wingdings symbol_map only
                 // contains PUA codepoints instead of the common ones.
-                glyph_t glyph = FT_Get_Char_Index(face, uc);
+                glyph__t glyph = FT_Get_Char_Index(face, uc);
                 // Certain symbol fonts don't have no-break space (0xa0) and tab (0x9),
                 // while we usually want to render them as space
                 if (!glyph && (uc == 0xa0 || uc == 0x9)) {
@@ -1709,7 +1709,7 @@ bool QFontEngineFT::stringToCMap(const Q
                     glyph = FT_Get_Char_Index(face, uc);
                     FT_Set_Charmap(face, freetype->unicode_map);
                 }
-                glyphs->glyphs[glyph_pos] = glyph;
+                glyphs->glyphs[glyph_pos] = {0, glyph};
                 if (uc < QFreetypeFace::cmapCacheSize)
                     freetype->cmapCache[uc] = glyph;
             }
@@ -1720,16 +1720,16 @@ bool QFontEngineFT::stringToCMap(const Q
         QStringIterator it(str, str + len);
         while (it.hasNext()) {
             uint uc = it.next();
-            glyphs->glyphs[glyph_pos] = uc < QFreetypeFace::cmapCacheSize ? freetype->cmapCache[uc] : 0;
-            if (!glyphs->glyphs[glyph_pos]) {
+            glyphs->glyphs[glyph_pos] = {0, uc < QFreetypeFace::cmapCacheSize ? freetype->cmapCache[uc] : 0};
+            if (!glyphs->glyphs[glyph_pos].glyph) {
                 {
                 redo:
-                    glyph_t glyph = FT_Get_Char_Index(face, uc);
+                    glyph__t glyph = FT_Get_Char_Index(face, uc);
                     if (!glyph && (uc == 0xa0 || uc == 0x9)) {
                         uc = 0x20;
                         goto redo;
                     }
-                    glyphs->glyphs[glyph_pos] = glyph;
+                    glyphs->glyphs[glyph_pos] = {0, glyph};
                     if (uc < QFreetypeFace::cmapCacheSize)
                         freetype->cmapCache[uc] = glyph;
                 }
@@ -1790,7 +1790,7 @@ void QFontEngineFT::recalcAdvances(QGlyp
     FT_Face face = 0;
     bool design = shouldUseDesignMetrics(flags);
     for (int i = 0; i < glyphs->numGlyphs; i++) {
-        Glyph *g = cacheEnabled ? defaultGlyphSet.getGlyph(glyphs->glyphs[i]) : 0;
+        Glyph *g = cacheEnabled ? defaultGlyphSet.getGlyph(glyphs->glyphs[i].glyph) : 0;
         // Since we are passing Format_None to loadGlyph, use same default format logic as loadGlyph
         GlyphFormat acceptableFormat = (defaultFormat != Format_None) ? defaultFormat : Format_Mono;
         if (g && g->format == acceptableFormat) {
@@ -1798,7 +1798,7 @@ void QFontEngineFT::recalcAdvances(QGlyp
         } else {
             if (!face)
                 face = lockFace();
-            g = loadGlyph(cacheEnabled ? &defaultGlyphSet : 0, glyphs->glyphs[i], 0, Format_None, true);
+            g = loadGlyph(cacheEnabled ? &defaultGlyphSet : 0, glyphs->glyphs[i].glyph, 0, Format_None, true);
             if (g)
                 glyphs->advances[i] = design ? QFixed::fromFixed(g->linearAdvance) : QFixed(g->advance);
             else
@@ -1837,11 +1837,11 @@ glyph_metrics_t QFontEngineFT::boundingB
     QFixed ymax = 0;
     QFixed xmax = 0;
     for (int i = 0; i < glyphs.numGlyphs; i++) {
-        Glyph *g = cacheEnabled ? defaultGlyphSet.getGlyph(glyphs.glyphs[i]) : 0;
+        Glyph *g = cacheEnabled ? defaultGlyphSet.getGlyph(glyphs.glyphs[i].glyph) : 0;
         if (!g) {
             if (!face)
                 face = lockFace();
-            g = loadGlyph(cacheEnabled ? &defaultGlyphSet : 0, glyphs.glyphs[i], 0, Format_None, true);
+            g = loadGlyph(cacheEnabled ? &defaultGlyphSet : 0, glyphs.glyphs[i].glyph, 0, Format_None, true);
         }
         if (g) {
             QFixed x = overall.xoff + glyphs.offsets[i].x + g->x;
@@ -1879,14 +1879,14 @@ glyph_metrics_t QFontEngineFT::boundingB
     return overall;
 }
 
-glyph_metrics_t QFontEngineFT::boundingBox(glyph_t glyph)
+glyph_metrics_t QFontEngineFT::boundingBox(const QGlyph &glyph)
 {
     FT_Face face = 0;
     glyph_metrics_t overall;
-    Glyph *g = cacheEnabled ? defaultGlyphSet.getGlyph(glyph) : 0;
+    Glyph *g = cacheEnabled ? defaultGlyphSet.getGlyph(glyph.glyph) : 0;
     if (!g) {
         face = lockFace();
-        g = loadGlyph(cacheEnabled ? &defaultGlyphSet : 0, glyph, 0, Format_None, true);
+        g = loadGlyph(cacheEnabled ? &defaultGlyphSet : 0, glyph.glyph, 0, Format_None, true);
     }
     if (g) {
         overall.x = g->x;
@@ -1918,14 +1918,14 @@ glyph_metrics_t QFontEngineFT::boundingB
     return overall;
 }
 
-glyph_metrics_t QFontEngineFT::boundingBox(glyph_t glyph, const QTransform &matrix)
+glyph_metrics_t QFontEngineFT::boundingBox(const QGlyph &glyph, const QTransform &matrix)
 {
     return alphaMapBoundingBox(glyph, 0, matrix, QFontEngine::Format_None);
 }
 
-glyph_metrics_t QFontEngineFT::alphaMapBoundingBox(glyph_t glyph, QFixed subPixelPosition, const QTransform &matrix, QFontEngine::GlyphFormat format)
+glyph_metrics_t QFontEngineFT::alphaMapBoundingBox(const QGlyph &glyph, QFixed subPixelPosition, const QTransform &matrix, QFontEngine::GlyphFormat format)
 {
-    Glyph *g = loadGlyphFor(glyph, subPixelPosition, format, matrix, true);
+    Glyph *g = loadGlyphFor(glyph.glyph, subPixelPosition, format, matrix, true);
 
     glyph_metrics_t overall;
     if (g) {
@@ -1986,7 +1986,7 @@ static inline QImage alphaMapFromGlyphDa
     return img;
 }
 
-QImage *QFontEngineFT::lockedAlphaMapForGlyph(glyph_t glyphIndex, QFixed subPixelPosition,
+QImage *QFontEngineFT::lockedAlphaMapForGlyph(const QGlyph &glyphIndex, QFixed subPixelPosition,
                                               QFontEngine::GlyphFormat neededFormat,
                                               const QTransform &t, QPoint *offset)
 {
@@ -1999,7 +1999,7 @@ QImage *QFontEngineFT::lockedAlphaMapFor
     else if (neededFormat == Format_None)
         neededFormat = Format_A8;
 
-    Glyph *glyph = loadGlyphFor(glyphIndex, subPixelPosition, neededFormat, t);
+    Glyph *glyph = loadGlyphFor(glyphIndex.glyph, subPixelPosition, neededFormat, t);
 
     if (offset != 0 && glyph != 0)
         *offset = QPoint(glyph->x, -glyph->y);
@@ -2035,7 +2035,7 @@ static inline bool is2dRotation(const QT
         && qFuzzyCompare(t.m11()*t.m22() - t.m12()*t.m21(), qreal(1.0));
 }
 
-QFontEngineFT::Glyph *QFontEngineFT::loadGlyphFor(glyph_t g,
+QFontEngineFT::Glyph *QFontEngineFT::loadGlyphFor(glyph__t g,
                                                   QFixed subPixelPosition,
                                                   GlyphFormat format,
                                                   const QTransform &t,
@@ -2064,16 +2064,16 @@ QFontEngineFT::Glyph *QFontEngineFT::loa
     return glyph;
 }
 
-QImage QFontEngineFT::alphaMapForGlyph(glyph_t g, QFixed subPixelPosition)
+QImage QFontEngineFT::alphaMapForGlyph(const QGlyph &g, QFixed subPixelPosition)
 {
     return alphaMapForGlyph(g, subPixelPosition, QTransform());
 }
 
-QImage QFontEngineFT::alphaMapForGlyph(glyph_t g, QFixed subPixelPosition, const QTransform &t)
+QImage QFontEngineFT::alphaMapForGlyph(const QGlyph &g, QFixed subPixelPosition, const QTransform &t)
 {
     const GlyphFormat neededFormat = antialias ? Format_A8 : Format_Mono;
 
-    Glyph *glyph = loadGlyphFor(g, subPixelPosition, neededFormat, t, false, true);
+    Glyph *glyph = loadGlyphFor(g.glyph, subPixelPosition, neededFormat, t, false, true);
 
     QImage img = alphaMapFromGlyphData(glyph, neededFormat);
     img = img.copy();
@@ -2084,14 +2084,14 @@ QImage QFontEngineFT::alphaMapForGlyph(g
     return img;
 }
 
-QImage QFontEngineFT::alphaRGBMapForGlyph(glyph_t g, QFixed subPixelPosition, const QTransform &t)
+QImage QFontEngineFT::alphaRGBMapForGlyph(const QGlyph &g, QFixed subPixelPosition, const QTransform &t)
 {
     if (t.type() > QTransform::TxRotate)
         return QFontEngine::alphaRGBMapForGlyph(g, subPixelPosition, t);
 
     const GlyphFormat neededFormat = Format_A32;
 
-    Glyph *glyph = loadGlyphFor(g, subPixelPosition, neededFormat, t, false, true);
+    Glyph *glyph = loadGlyphFor(g.glyph, subPixelPosition, neededFormat, t, false, true);
 
     QImage img = alphaMapFromGlyphData(glyph, neededFormat);
     img = img.copy();
@@ -2105,11 +2105,11 @@ QImage QFontEngineFT::alphaRGBMapForGlyp
     return QFontEngine::alphaRGBMapForGlyph(g, subPixelPosition, t);
 }
 
-QImage QFontEngineFT::bitmapForGlyph(glyph_t g, QFixed subPixelPosition, const QTransform &t, const QColor &color)
+QImage QFontEngineFT::bitmapForGlyph(const QGlyph &g, QFixed subPixelPosition, const QTransform &t, const QColor &color)
 {
     Q_UNUSED(color);
 
-    Glyph *glyph = loadGlyphFor(g, subPixelPosition, defaultFormat, t);
+    Glyph *glyph = loadGlyphFor(g.glyph, subPixelPosition, defaultFormat, t);
     if (glyph == nullptr)
         return QImage();
 
@@ -2132,9 +2132,9 @@ QImage QFontEngineFT::bitmapForGlyph(gly
     return img;
 }
 
-void QFontEngineFT::removeGlyphFromCache(glyph_t glyph)
+void QFontEngineFT::removeGlyphFromCache(const QGlyph &glyph)
 {
-    defaultGlyphSet.removeGlyphFromCache(glyph, 0);
+    defaultGlyphSet.removeGlyphFromCache(glyph.glyph, 0);
 }
 
 int QFontEngineFT::glyphCount() const
@@ -2215,7 +2215,7 @@ void QFontEngineFT::QGlyphSet::clear()
     glyph_data.clear();
 }
 
-void QFontEngineFT::QGlyphSet::removeGlyphFromCache(glyph_t index, QFixed subPixelPosition)
+void QFontEngineFT::QGlyphSet::removeGlyphFromCache(glyph__t index, QFixed subPixelPosition)
 {
     if (useFastGlyphData(index, subPixelPosition)) {
         if (fast_glyph_data[index]) {
@@ -2229,7 +2229,7 @@ void QFontEngineFT::QGlyphSet::removeGly
     }
 }
 
-void QFontEngineFT::QGlyphSet::setGlyph(glyph_t index, QFixed subPixelPosition, Glyph *glyph)
+void QFontEngineFT::QGlyphSet::setGlyph(glyph__t index, QFixed subPixelPosition, Glyph *glyph)
 {
     if (useFastGlyphData(index, subPixelPosition)) {
         if (!fast_glyph_data[index])
@@ -2240,7 +2240,7 @@ void QFontEngineFT::QGlyphSet::setGlyph(
     }
 }
 
-int QFontEngineFT::getPointInOutline(glyph_t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints)
+int QFontEngineFT::getPointInOutline(glyph__t glyph, int flags, quint32 point, QFixed *xpos, QFixed *ypos, quint32 *nPoints)
 {
     lockFace();
     bool hsubpixel = true;
